#!/usr/bin/python
# coding: utf8
#Boa:Frame:FBase

import wx
import wx.lib.buttons
import serial
import time

portCom = serial.Serial()
portCom.port = '/dev/ttyACM0'
portCom.baudrate = 115200
 

def create(parent):
    return FBase(parent)

[wxID_FBASE, wxID_FBASEALLUMER, wxID_FBASEETEINDRE, wxID_FBASEQUITTER, 
 wxID_FBASEVOYANT, 
] = [wx.NewId() for _init_ctrls in range(5)]

class FBase(wx.Frame):
    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wx.Frame.__init__(self, id=wxID_FBASE, name=u'FBase', parent=prnt,
              pos=wx.Point(542, 376), size=wx.Size(227, 168),
              style=wx.DEFAULT_FRAME_STYLE | wx.CLOSE_BOX | wx.MINIMIZE_BOX | wx.CAPTION,
              title=u'Commande LED')
        self.SetClientSize(wx.Size(223, 135))

        self.Allumer = wx.lib.buttons.GenButton(id=wxID_FBASEALLUMER,
              label=u'Allumer', name=u'Allumer', parent=self, pos=wx.Point(16,
              16), size=wx.Size(86, 31), style=0)
        self.Allumer.Bind(wx.EVT_BUTTON, self.OnAllumerButton,
              id=wxID_FBASEALLUMER)

        self.Eteindre = wx.lib.buttons.GenButton(id=wxID_FBASEETEINDRE,
              label=u'\xc9teindre', name=u'Eteindre', parent=self,
              pos=wx.Point(16, 56), size=wx.Size(86, 31), style=0)
        self.Eteindre.Bind(wx.EVT_BUTTON, self.OnEteindreButton,
              id=wxID_FBASEETEINDRE)

        self.Quitter = wx.lib.buttons.GenButton(id=wxID_FBASEQUITTER,
              label=u'Quitter', name=u'Quitter', parent=self, pos=wx.Point(128,
              96), size=wx.Size(86, 31), style=0)
        self.Quitter.Bind(wx.EVT_BUTTON, self.OnQuitterButton,
              id=wxID_FBASEQUITTER)

        self.Voyant = wx.StaticBitmap(bitmap=wx.Bitmap(u'voyant_off.png',
              wx.BITMAP_TYPE_PNG), id=wxID_FBASEVOYANT, name=u'Voyant',
              parent=self, pos=wx.Point(152, 32), size=wx.Size(32, 32),
              style=0)

    def __init__(self, parent):
        self._init_ctrls(parent)
        try:
            portCom.open()
        except serial.SerialException:
            import Dialog1 
            dlg = Dialog1.Dialog1(self)
            try:
                dlg.ShowModal()
            finally:
                dlg.Destroy()            

    def OnQuitterButton(self, event):
        self.Close()

    def majLed(self, commande):
        portCom.write(commande)
        time.sleep(0.05)
        nbCar = portCom.in_waiting
        retour = portCom.read(nbCar)
        if (retour == "ledOn"):
            bitmap=wx.Bitmap(u"voyant_on.png",wx.BITMAP_TYPE_PNG)
        else:
            bitmap=wx.Bitmap(u"voyant_off.png",wx.BITMAP_TYPE_PNG)
        self.Voyant.SetBitmap(bitmap)

    def OnAllumerButton(self, event):
        self.majLed("on")

    def OnEteindreButton(self, event):
        self.majLed("off")

if __name__ == '__main__':
    app = wx.App()
    frame = create(None)
    frame.Show()

    app.MainLoop()
